/*
   FNT - SQL-backend for MySQL - function get_field_value_by_name

   Copyright (C) 2009 Free Software Foundation, Inc.

   Written by:
   Slava Zanko <slavazanko@gmail.com>


   This file is part of the FIDO New Technology.

   FIDO New Technology is free software: you can redistribute it and/or 
   modify it under the terms of the GNU General Public License as published 
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifdef HAVE_CONFIG_H
#	include <config.h>
#endif

#include <mysql.h>
#include <stdlib.h>
#include <string.h>

#include "../include/global.h"

#include "../include/types.h"
#include "../include/error.h"
#include "../include/plugin.h"
#include "../include/sql.h"

#include "main.h"

/*** global variables **************************************************/

/*** file scope macro definitions **************************************/

/*** file scope type declarations **************************************/

/*** file scope variables **********************************************/

/*** file scope functions **********************************************/

/*** public functions **************************************************/

DLLEXPORT char *
get_field_value_by_name (fnt_sql_row_t * row, const char *field_name)
{
    int field_num;
    MYSQL_FIELD *fields;

    if (row == NULL || field_name == NULL)
	return NULL;

    if (row->query->is_result_present == false)
	return NULL;

    fields = mysql_fetch_fields ((MYSQL_RES *) row->query->handle);
    for (field_num = 0; field_num < row->query->num_fields; field_num++)
    {
	if (strcmp (field_name, fields[field_num].name) == 0)
	    break;
    }
    if (field_num == row->query->num_fields)
	return NULL;

    return fnt_sql_getValueByFieldNumber (row, field_num);
}
